## ros-kinetic-ecto-opencv 0.7.2

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8)
project(ecto_opencv)

find_package(cv_backports QUIET)
if(cv_backports_FOUND)
find_package(catkin REQUIRED ecto opencv_candidate cv_backports)
catkin_package(DEPENDS ecto opencv_candidate cv_backports)
else()
find_package(catkin REQUIRED ecto opencv_candidate)
catkin_package(DEPENDS ecto opencv_candidate)
endif()

if(NOT CMAKE_BUILD_TYPE)#Only do this the on the first run, if the build type hasn't been set prior
  set(CMAKE_BUILD_TYPE RelWithDebInfo CACHE STRING
      "Choose the type of build, options are: None Debug Release RelWithDebInfo MinSizeRel."
      FORCE)
endif()

find_package(OpenCV REQUIRED)
message(STATUS "OpenCV version: ${OpenCV_VERSION}")
message(STATUS "OpenCV headers: ${OpenCV_INCLUDE_DIRS}")
include_directories(SYSTEM ${OpenCV_INCLUDE_DIRS} ${catkin_INCLUDE_DIRS})

find_package(Boost COMPONENTS serialization filesystem system REQUIRED)

if(NOT CMAKE_LIBRARY_OUTPUT_DIRECTORY)
  set(CMAKE_LIBRARY_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/lib)
endif()

# configure and install Python
catkin_python_setup()

add_subdirectory(cells)
add_subdirectory(python)

if(CATKIN_ENABLE_TESTING)
  add_subdirectory(test)
  add_subdirectory(samples)
endif()

ecto_sphinx(${CMAKE_CURRENT_SOURCE_DIR}/doc doc)

=== python/CMakeLists.txt ===
configure_file(__init__.py.plain.in
               ${CATKIN_DEVEL_PREFIX}/${CATKIN_PACKAGE_PYTHON_DESTINATION}/ecto_cells/__init__.py
               @ONLY
)

install(FILES ${CATKIN_DEVEL_PREFIX}/${CATKIN_PACKAGE_PYTHON_DESTINATION}/ecto_cells/__init__.py
        DESTINATION ${CATKIN_PACKAGE_PYTHON_DESTINATION}/ecto_cells/
)

=== cells/cv_bp/CMakeLists.txt ===
project(cv_bp)
add_subdirectory(opencv)

=== cells/cv_bp/opencv/CMakeLists.txt ===
find_package(OpenCV REQUIRED core highgui)
find_package(Boost COMPONENTS
  python
  REQUIRED
  )
  
set(CMAKE_BUILD_TYPE Debug)

find_package(PythonLibs
  REQUIRED)

list(APPEND CMAKE_MODULE_PATH ${CMAKE_CURRENT_SOURCE_DIR})
find_package(numpy)
if(numpy-NOTFOUND)
    message(WARNING "Not building cv_bp as it requires numpy")
    return()
endif()
#detect the python version and install directories
find_package(PythonInterp REQUIRED)

if(NOT PYTHON_PACKAGES_PATH )
  execute_process(COMMAND ${PYTHON_EXECUTABLE} --version
    ERROR_VARIABLE PYTHON_VERSION_FULL
    OUTPUT_STRIP_TRAILING_WHITESPACE)
  
  string(REGEX MATCH "[0-9].[0-9]" PYTHON_VERSION_MAJOR_MINOR "${PYTHON_VERSION_FULL}")
  
  if(UNIX)
    if(APPLE)
      set(PYTHON_PACKAGES_PATH lib/python${PYTHON_VERSION_MAJOR_MINOR}/site-packages 
        CACHE PATH "Where to install the python packages.")
    else() #debian based assumed, install to the dist-packages.
      set(PYTHON_PACKAGES_PATH lib/python${PYTHON_VERSION_MAJOR_MINOR}/dist-packages 
        CACHE PATH "Where to install the python packages.")
    endif()
  elseif(WIN32)
    get_filename_component(PYTHON_PATH "[HKEY_LOCAL_MACHINE\\SOFTWARE\\Python\\PythonCore\\${PYTHON_VERSION_MAJOR_MINOR}\\InstallPath]" ABSOLUTE CACHE)
    set(PYTHON_PACKAGES_PATH "${PYTHON_PATH}/Lib/site-packages" 
      CACHE PATH "Where to install the python packages.")
  endif()
  
endif()

include_directories(
  ${PYTHON_INCLUDE_PATH}
  ${Boost_INCLUDE_DIRS}
  ${PYTHON_NUMPY_INCLUDE_DIR}
  )

set(bp_opencv_target opencv_boost_python)

add_library(${bp_opencv_target} SHARED
  opencv.cpp
  cv_core.cpp
  cv_mat.cpp
  cv_points.cpp
  cv_highgui.cpp
  highgui_defines.cpp
  )

set_target_properties(${bp_opencv_target}
  PROPERTIES
  LIBRARY_OUTPUT_DIRECTORY ${CATKIN_DEVEL_PREFIX}/${CATKIN_PACKAGE_PYTHON_DESTINATION}/
  OUTPUT_NAME cv_bp
  PREFIX ""
  )

target_link_libraries(${bp_opencv_target}
  ${Boost_LIBRARIES}
  ${PYTHON_LIBRARIES}
  ${OpenCV_LIBS}
  ${cv_backports_LIBRARIES}
  )

install(TARGETS ${bp_opencv_target}
  LIBRARY DESTINATION ${CATKIN_PACKAGE_PYTHON_DESTINATION}/ COMPONENT main)

=== cells/opencv/calib/CMakeLists.txt ===

ectomodule(calib DESTINATION ecto_opencv
                 INSTALL
  module.cpp
  calib.cpp 
  CameraIntrinsics.cpp
  PatternDrawer.cpp
  PatternDetector.cpp
  CircleDrawer.cpp
  SubrectRectifier.cpp
  DepthTo3d.cpp
  pose_drawing.cpp
  KConverter.cpp
  Latch.cpp
  TransformCompose.cpp
  FiducialPoseEst.cpp
  CameraCalibrator.cpp
  GatherPoints.cpp
  DepthMask.cpp
  PointsTo3d.cpp
  CropBox.cpp
  )

link_ecto(calib ${catkin_LIBRARIES}
                ${opencv_candidate_LIBRARIES}
                ${OpenCV_LIBRARIES}
)

=== cells/opencv/features2d/CMakeLists.txt ===
ectomodule(features2d DESTINATION ecto_opencv/ecto_cells
                      INSTALL
  module.cpp
  DescriptorExtractor.cpp
  DrawKeypoints.cpp
  FeatureDetector.cpp
  KeypointsToMat.cpp
  LshMatcher.cpp
  MatchesToMat.cpp
  match_draw.cpp
  matcher.cpp
  ORB.cpp
  ransac_est.cpp
  )

find_package(OpenCV REQUIRED)
link_ecto(features2d ${catkin_LIBRARIES}
                     ${OpenCV_LIBRARIES}
)

=== cells/opencv/rgbd/CMakeLists.txt ===
ectomodule(rgbd DESTINATION ecto_opencv
                INSTALL
                Cleaner.cpp
                ClusterDrawer.cpp
                DepthSwapper.cpp
                module.cpp
                Normal.cpp
                Odometry.cpp
                OnPlaneClusterer.cpp
                Plane.cpp
)

link_ecto(rgbd ${catkin_LIBRARIES}
               ${OpenCV_LIBRARIES}
)

=== debian/changelog ===
ros-kinetic-ecto-opencv (0.7.2-0xenial) xenial; urgency=high

  * Fix compilation on x86 where float is a long double
  * Contributors: Vincent Rabaud

 -- Vincent Rabaud <vincent.rabaud@gmail.com>  Wed, 08 Nov 2017 23:00:00 -0000

ros-kinetic-ecto-opencv (0.7.1-0xenial) xenial; urgency=high

  * fix compilation with OpenCV 3.3
  * Contributors: Vincent Rabaud

 -- Vincent Rabaud <vincent.rabaud@gmail.com>  Wed, 08 Nov 2017 23:00:00 -0000

ros-kinetic-ecto-opencv (0.7.0-0xenial) xenial; urgency=high

  * make master Kinetic and above only
    This is because OpenCV3 is the default and cv_backports is now
    useless.
  * Contributors: Vincent Rabaud

 -- Vincent Rabaud <vincent.rabaud@gmail.com>  Sat, 23 Apr 2016 22:00:00 -0000

ros-kinetic-ecto-opencv (0.6.2-0xenial) xenial; urgency=high

  * fix compilation with OpenCV3
  * Fix version check logic
  * Contributors: Scott K Logan, Vincent Rabaud

 -- Vincent Rabaud <vincent.rabaud@gmail.com>  Sat, 23 Apr 2016 22:00:00 -0000

ros-kinetic-ecto-opencv (0.6.1-0xenial) xenial; urgency=high

  * Fix compatibility with OpenCV 2.4.11+
  * Contributors: Scott K Logan, Vincent Rabaud

 -- Vincent Rabaud <vincent.rabaud@gmail.com>  Sun, 30 Aug 2015 22:00:00 -0000

ros-kinetic-ecto-opencv (0.6.0-0xenial) xenial; urgency=high

  * add proper rosunit dependency
  * convert Python tests to proper nose tests
  * use cv_backports to pull in opencv2.4.9 imshows with zoom and parallel thread support.
  * Contributors: Daniel Stonier, Vincent Rabaud

 -- Vincent Rabaud <vincent.rabaud@gmail.com>  Fri, 08 May 2015 22:00:00 -0000

ros-kinetic-ecto-opencv (0.5.6-0xenial) xenial; urgency=high

  * fix non-existence of radiusMatch for LSH
  * Contributors: Vincent Rabaud

 -- Vincent Rabaud <vincent.rabaud@gmail.com>  Sat, 18 Apr 2015 22:00:00 -0000

ros-kinetic-ecto-opencv (0.5.5-0xenial) xenial; urgency=high

  * compile with the latest opencv_candidate
  * use OpenCV's LSH
  * remove useless file
  * clean extensions
  * Contributors: Vincent Rabaud

 -- Vincent Rabaud <vincent.rabaud@gmail.com>  Sat, 28 Mar 2015 23:00:00 -0000

ros-kinetic-ecto-opencv (0.5.4-0xenial) xenial; urgency=high

  * remove SSE dependency
    That would not work on ARM as explained in #29 <https://github.com/plasmodic/ecto_opencv/issues/29> plus it is useless
    now: opencv_candidate deals with it and it uses OpenCV flags
  * Contributors: Vincent Rabaud

 -- Vincent Rabaud <vincent.rabaud@gmail.com>  Fri, 02 Jan 2015 23:00:00 -0000

ros-kinetic-ecto-opencv (0.5.3-0xenial) xenial; urgency=high

  * Added FPS scale param
  * recursive directory creation.
  * speedup normal display
  * fix depth cleaner
  * add a normal sample
  * Contributors: Daniel Stonier, Vincent Rabaud, kentsommer

 -- Vincent Rabaud <vincent.rabaud@gmail.com>  Sat, 26 Jul 2014 22:00:00 -0000

ros-kinetic-ecto-opencv (0.5.2-0xenial) xenial; urgency=high

  * rely on opencv_candidate to get the OpenCV dependency
  * Contributors: Vincent Rabaud

 -- Vincent Rabaud <vincent.rabaud@gmail.com>  Sat, 12 Apr 2014 22:00:00 -0000

ros-kinetic-ecto-opencv (0.5.1-0xenial) xenial; urgency=high

  * get code to compile on Indigo
  * fix shadow effect on clusters
  * Contributors: Vincent Rabaud

 -- Vincent Rabaud <vincent.rabaud@gmail.com>  Sat, 12 Apr 2014 22:00:00 -0000

ros-kinetic-ecto-opencv (0.5.0-0xenial) xenial; urgency=high

  * drop Fuerte support
  * fix compatibility with Boost until 1.54

 -- Vincent Rabaud <vincent.rabaud@gmail.com>  Wed, 18 Dec 2013 21:12:06 +0100

=== debian/control ===
Source: ros-kinetic-ecto-opencv
Section: misc
Priority: extra
Maintainer: Vincent Rabaud <vincent.rabaud@gmail.com>
Build-Depends: debhelper (>= 9.0.0), libboost-all-dev, ros-kinetic-catkin, ros-kinetic-ecto, ros-kinetic-opencv-candidate, ros-kinetic-rosunit
Homepage: http://plasmodic.github.io/ecto_opencv
Standards-Version: 3.9.2

Package: ros-kinetic-ecto-opencv
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libboost-all-dev, ros-kinetic-ecto, ros-kinetic-opencv-candidate
Description: Ecto bindings for common opencv functionality.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/kinetic/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG

%:
	dh $@ -v --buildsystem=cmake

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/kinetic/setup.sh" ]; then . "/opt/ros/kinetic/setup.sh"; fi && \
	dh_auto_configure -- \
		-DCATKIN_BUILD_BINARY_PACKAGE="1" \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/kinetic" \
		-DCMAKE_PREFIX_PATH="/opt/ros/kinetic"

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/kinetic/setup.sh" ]; then . "/opt/ros/kinetic/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/kinetic/setup.sh" ]; then . "/opt/ros/kinetic/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/kinetic/setup.sh" ]; then . "/opt/ros/kinetic/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-kinetic-ecto-opencv//opt/ros/kinetic/lib/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/kinetic/setup.sh" ]; then . "/opt/ros/kinetic/setup.sh"; fi && \
	dh_auto_install
